## ogre 1.7.4+dfsg1

=== CMakeLists.txt ===
#-------------------------------------------------------------------
# This file is part of the CMake build system for OGRE
#     (Object-oriented Graphics Rendering Engine)
# For the latest info, see http://www.ogre3d.org/
#
# The contents of this file are placed in the public domain. Feel
# free to make use of it in any way you like.
#-------------------------------------------------------------------

######################################################################
# OGRE BUILD SYSTEM
# Welcome to the CMake build system for OGRE.
# This is the main file where we prepare the general build environment
# and provide build configuration options.
######################################################################

cmake_minimum_required(VERSION 2.6.2)
set(CMAKE_ALLOW_LOOSE_LOOP_CONSTRUCTS TRUE)
cmake_policy(SET CMP0003 NEW)

# CMake 2.8.2 has a bug that creates unusable Xcode projects when using ARCHS_STANDARD_32_BIT
# to specify both armv6 and armv7.
if(OGRE_BUILD_PLATFORM_IPHONE AND (CMAKE_VERSION VERSION_EQUAL 2.8.2) AND (CMAKE_GENERATOR STREQUAL "Xcode"))
	message(FATAL_ERROR "CMake 2.8.2 cannot create compatible Xcode projects for iOS, please download the latest version or an older release from http://www.cmake.org/files/")
endif()

# Use relative paths
# This is mostly to reduce path size for command-line limits on windows
if(WIN32)
  # This seems to break Xcode projects so definitely don't enable on Apple builds
  set(CMAKE_USE_RELATIVE_PATHS true)
  set(CMAKE_SUPPRESS_REGENERATION true)
endif()

# Assign compiler for Mac OS X-based systems
# NOTE: This logic is order-dependent and must occur here because the
# configuration phase of CMake projects will fall into an infinite loop
# if compiler assignments are modified after issuing a project(...) command.
#
if (OGRE_BUILD_PLATFORM_IPHONE)
  # Force gcc <= 4.2 on iPhone
  include(CMakeForceCompiler)
  CMAKE_FORCE_C_COMPILER(g++-4.2 GNU)
  CMAKE_FORCE_CXX_COMPILER(g++-4.2 GNU)
endif ()

project(OGRE)

# Include necessary submodules
set(CMAKE_MODULE_PATH 
  "${OGRE_SOURCE_DIR}/CMake"
  "${OGRE_SOURCE_DIR}/CMake/Utils" 
  "${OGRE_SOURCE_DIR}/CMake/Packages"
)
include(CMakeDependentOption)
include(CheckCXXCompilerFlag)
include(MacroLogFeature)
include(OgreConfigTargets)
include(PreprocessorUtils)
set(OGRE_TEMPLATES_DIR "${OGRE_SOURCE_DIR}/CMake/Templates")
set(OGRE_WORK_DIR ${OGRE_BINARY_DIR})


#####################################################################
# Set up the basic build environment
#####################################################################

if (CMAKE_BUILD_TYPE STREQUAL "")
  # CMake defaults to leaving CMAKE_BUILD_TYPE empty. This screws up
  # differentiation between debug and release builds.
  set(CMAKE_BUILD_TYPE "RelWithDebInfo" CACHE STRING "Choose the type of build, options are: None (CMAKE_CXX_FLAGS or CMAKE_C_FLAGS used) Debug Release RelWithDebInfo MinSizeRel." FORCE)
endif ()

# determine Ogre version numbers
include(OgreGetVersion)
ogre_get_version(${OGRE_SOURCE_DIR}/OgreMain/include/OgrePrerequisites.h)
message(STATUS "Configuring OGRE ${OGRE_VERSION}")
# Configure version file for use by scripts
configure_file("${OGRE_TEMPLATES_DIR}/version.txt.in" "${OGRE_BINARY_DIR}/version.txt" @ONLY)

# determine if we are compiling for a 32bit or 64bit system
include(CheckTypeSize)
CHECK_TYPE_SIZE("void*" OGRE_PTR_SIZE BUILTIN_TYPES_ONLY)
if (OGRE_PTR_SIZE EQUAL 8)
  set(OGRE_PLATFORM_X64 TRUE)
else ()
  set(OGRE_PLATFORM_X64 FALSE)
endif ()

if (NOT APPLE)
  # Create debug libraries with _d postfix
  set(CMAKE_DEBUG_POSTFIX "_d")
endif ()

# Set compiler specific build flags
if (CMAKE_COMPILER_IS_GNUCXX)
  check_cxx_compiler_flag(-msse OGRE_GCC_HAS_SSE)
  if (OGRE_GCC_HAS_SSE)
    add_definitions(-msse)
  endif ()
endif ()
if (MSVC)
  if (CMAKE_BUILD_TOOL STREQUAL "nmake")
    # set variable to state that we are using nmake makefiles
	set(NMAKE TRUE)
  endif ()
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /fp:fast")
  # Enable intrinsics on MSVC in debug mode
  set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} /Oi")
  if (CMAKE_CL_64)
    # Visual Studio bails out on debug builds in 64bit mode unless
	# this flag is set...
	set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} /bigobj")
	set(CMAKE_CXX_FLAGS_RELWITHDEBINFO "${CMAKE_CXX_FLAGS_RELWITHDEBINFO} /bigobj")
  endif ()
endif ()
if (MINGW)
  add_definitions(-D_WIN32_WINNT=0x0500)
endif ()

if (CMAKE_COMPILER_IS_GNUCXX AND NOT MINGW)
  # Test for GCC visibility
  include(CheckCXXCompilerFlag)
  check_cxx_compiler_flag(-fvisibility=hidden OGRE_GCC_VISIBILITY)
  if (OGRE_GCC_VISIBILITY)
    # determine gcc version
    execute_process(COMMAND ${CMAKE_CXX_COMPILER} -dumpversion 
      OUTPUT_VARIABLE OGRE_GCC_VERSION)
    message(STATUS "Detected g++ ${OGRE_GCC_VERSION}")
    message(STATUS "Enabling GCC visibility flags")
    set(OGRE_GCC_VISIBILITY_FLAGS "-DOGRE_GCC_VISIBILITY -fvisibility=hidden")
    set(XCODE_ATTRIBUTE_GCC_SYMBOLS_PRIVATE_EXTERN "YES")
  
    # check if we can safely add -fvisibility-inlines-hidden
    string(TOLOWER "${CMAKE_BUILD_TYPE}" OGRE_BUILD_TYPE)
    if (OGRE_BUILD_TYPE STREQUAL "debug" AND OGRE_GCC_VERSION VERSION_LESS "4.2")
      message(STATUS "Skipping -fvisibility-inlines-hidden due to possible bug in g++ < 4.2")
    else ()
      set(OGRE_GCC_VISIBILITY_FLAGS "${OGRE_GCC_VISIBILITY_FLAGS} -fvisibility-inlines-hidden")
      set(XCODE_ATTRIBUTE_GCC_INLINES_ARE_PRIVATE_EXTERN "YES")
    endif ()
  endif (OGRE_GCC_VISIBILITY)
  
  # Fix x64 issues on Linux
  if(OGRE_PLATFORM_X64 AND NOT APPLE)
    add_definitions(-fPIC)
  endif()  
endif (CMAKE_COMPILER_IS_GNUCXX AND NOT MINGW)

# determine system endianess
if (MSVC)
  # This doesn't work on VS 2010
  # MSVC only builds for intel anyway
  set(OGRE_TEST_BIG_ENDIAN FALSE)
else()
  include(TestBigEndian)
  test_big_endian(OGRE_TEST_BIG_ENDIAN)
endif()

# Add OgreMain include path
include_directories("${OGRE_SOURCE_DIR}/OgreMain/include")
include_directories("${OGRE_BINARY_DIR}/include")
if (APPLE)
  if (OGRE_BUILD_PLATFORM_IPHONE)
    include_directories("${OGRE_SOURCE_DIR}/OgreMain/include/iPhone")

    # Set static early for proper dependency detection
    set(OGRE_STATIC TRUE)
  else ()
    include_directories("${OGRE_SOURCE_DIR}/OgreMain/include/OSX")
  endif ()
endif (APPLE)

# Find dependencies
include(Dependencies)
# definitions for samples
set(OGRE_LIBRARIES OgreMain) 
set(OGRE_Paging_LIBRARIES OgrePaging)
set(OGRE_Terrain_LIBRARIES OgreTerrain)
set(OGRE_Plugin_PCZSceneManager_LIBRARIES Plugin_PCZSceneManager)
set(OGRE_Plugin_OctreeZone_LIBRARIES Plugin_OctreeZone)

# Specify build paths
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY "${OGRE_BINARY_DIR}/lib")
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY "${OGRE_BINARY_DIR}/lib")
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY "${OGRE_BINARY_DIR}/bin")
if (WIN32 OR APPLE)
  if (CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
    # We don't want to install in default system location, install is really for the SDK, so call it that
    set(CMAKE_INSTALL_PREFIX
	  "${OGRE_BINARY_DIR}/sdk" CACHE PATH "OGRE install prefix" FORCE
    )
  endif (CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
endif(WIN32 OR APPLE)

# Set up iPhone overrides.
if (OGRE_BUILD_PLATFORM_IPHONE)
  include_directories("${OGRE_SOURCE_DIR}/OgreMain/include/iPhone")

  # Set build variables
  set(CMAKE_OSX_SYSROOT iphoneos)
  set(CMAKE_OSX_DEPLOYMENT_TARGET "")
  set(CMAKE_EXE_LINKER_FLAGS "-framework Foundation -framework CoreGraphics -framework QuartzCore -framework UIKit")
  set(XCODE_ATTRIBUTE_SDKROOT iphoneos)
  set(OGRE_BUILD_RENDERSYSTEM_GLES TRUE CACHE BOOL "Forcing OpenGL ES RenderSystem for iPhone" FORCE)
  set(OGRE_STATIC TRUE CACHE BOOL "Forcing static build for iPhone" FORCE)
  set(MACOSX_BUNDLE_GUI_IDENTIFIER "com.yourcompany.\${PRODUCT_NAME:rfc1034identifier}")
  set(OGRE_CONFIG_ENABLE_VIEWPORT_ORIENTATIONMODE TRUE CACHE BOOL "Forcing viewport orientation support for iPhone" FORCE)

  set(CMAKE_OSX_ARCHITECTURES $(ARCHS_STANDARD_32_BIT))
  # armv7 only
  #set(CMAKE_OSX_ARCHITECTURES $(ARCHS_UNIVERSAL_IPHONE_OS))

  remove_definitions(-msse)
elseif (APPLE AND NOT OGRE_BUILD_PLATFORM_IPHONE)

  # Set 10.5 as the base SDK by default
  set(XCODE_ATTRIBUTE_SDKROOT macosx)
  set(CMAKE_OSX_SYSROOT macosx)
  set(CMAKE_OSX_DEPLOYMENT_TARGET 10.5)

  if (NOT CMAKE_OSX_ARCHITECTURES)
    set(CMAKE_OSX_ARCHITECTURES $(ARCHS_STANDARD_32_64_BIT))
  endif()

  # Make sure that the OpenGL render system is selected for non-iPhone Apple builds
  set(OGRE_BUILD_RENDERSYSTEM_GL TRUE)
  set(OGRE_BUILD_RENDERSYSTEM_GLES FALSE)
endif ()

# Enable the PVRTC codec if OpenGL ES is being built
if(OGRE_BUILD_RENDERSYSTEM_GLES)
  set(OGRE_CONFIG_ENABLE_PVRTC TRUE CACHE BOOL "Forcing PVRTC codec for OpenGL ES" FORCE)
endif()

######################################################################
# Provide user options to customise the build process
######################################################################

# Customise what to build
option(OGRE_STATIC "Static build" FALSE)
cmake_dependent_option(OGRE_BUILD_RENDERSYSTEM_D3D9 "Build Direct3D9 RenderSystem" TRUE "WIN32;DirectX_FOUND" FALSE)
cmake_dependent_option(OGRE_BUILD_RENDERSYSTEM_D3D10 "Build Direct3D10 RenderSystem [EXPERIMENTAL]" FALSE "WIN32;DirectX_D3D10_FOUND" FALSE)
cmake_dependent_option(OGRE_BUILD_RENDERSYSTEM_D3D11 "Build Direct3D11 RenderSystem [EXPERIMENTAL]" FALSE "WIN32;DirectX_D3D11_FOUND" FALSE)
cmake_dependent_option(OGRE_BUILD_RENDERSYSTEM_GL "Build OpenGL RenderSystem" TRUE "OPENGL_FOUND;NOT OGRE_BUILD_PLATFORM_IPHONE" FALSE)
cmake_dependent_option(OGRE_BUILD_RENDERSYSTEM_GLES "Build OpenGL ES RenderSystem" FALSE "OPENGLES_FOUND" FALSE)
cmake_dependent_option(OGRE_BUILD_PLATFORM_IPHONE "Build Ogre for iPhone OS" FALSE "APPLE;OPENGLES_FOUND" FALSE)
option(OGRE_BUILD_PLUGIN_BSP "Build BSP SceneManager plugin" TRUE)
option(OGRE_BUILD_PLUGIN_OCTREE "Build Octree SceneManager plugin" TRUE)
option(OGRE_BUILD_PLUGIN_PCZ "Build PCZ SceneManager plugin" TRUE)
option(OGRE_BUILD_PLUGIN_PFX "Build ParticleFX plugin" TRUE)
option(OGRE_BUILD_COMPONENT_PAGING "Build Paging component" TRUE)
option(OGRE_BUILD_COMPONENT_TERRAIN "Build Terrain component" TRUE)
cmake_dependent_option(OGRE_BUILD_COMPONENT_PROPERTY "Build Property component" TRUE "Boost_FOUND" FALSE)
cmake_dependent_option(OGRE_BUILD_PLUGIN_CG "Build Cg plugin" TRUE "Cg_FOUND;NOT OGRE_BUILD_PLATFORM_IPHONE" FALSE)
option(OGRE_BUILD_COMPONENT_RTSHADERSYSTEM "Build RTShader System component" TRUE)
cmake_dependent_option(OGRE_BUILD_RTSHADERSYSTEM_CORE_SHADERS "Build RTShader System FFP core shaders" TRUE "OGRE_BUILD_COMPONENT_RTSHADERSYSTEM" FALSE)
cmake_dependent_option(OGRE_BUILD_RTSHADERSYSTEM_EXT_SHADERS "Build RTShader System extensions shaders" TRUE "OGRE_BUILD_COMPONENT_RTSHADERSYSTEM" FALSE)

option(OGRE_BUILD_SAMPLES "Build Ogre demos" TRUE)
cmake_dependent_option(OGRE_BUILD_TOOLS "Build the command-line tools" TRUE "NOT OGRE_BUILD_PLATFORM_IPHONE" FALSE)
option(OGRE_BUILD_TESTS "Build the unit tests & PlayPen" FALSE)
option(OGRE_CONFIG_DOUBLE "Use doubles instead of floats in Ogre" FALSE)
set(OGRE_CONFIG_ALLOCATOR 4 CACHE STRING
"Specify the memory allocator to use. Possible values:
  1 - Standard allocator
  2 - nedmalloc
  3 - User-provided allocator
  4 - nedmalloc with pooling"
)
option(OGRE_CONFIG_CONTAINERS_USE_CUSTOM_ALLOCATOR "STL containers in Ogre use the custom allocator" TRUE)
option(OGRE_CONFIG_STRING_USE_CUSTOM_ALLOCATOR "Ogre String uses the custom allocator" FALSE)
option(OGRE_CONFIG_MEMTRACK_DEBUG "Enable Ogre's memory tracker in debug mode" FALSE)
option(OGRE_CONFIG_MEMTRACK_RELEASE "Enable Ogre's memory tracker in release mode" FALSE)
# determine threading options
include(PrepareThreadingOptions)
cmake_dependent_option(OGRE_CONFIG_ENABLE_FREEIMAGE "Build FreeImage codec. If you disable this option, you need to provide your own image handling codecs." TRUE "FreeImage_FOUND" FALSE)

=== CMake/CMakeLists.txt ===
#-------------------------------------------------------------------
# This file is part of the CMake build system for OGRE
#     (Object-oriented Graphics Rendering Engine)
# For the latest info, see http://www.ogre3d.org/
#
# The contents of this file are placed in the public domain. Feel
# free to make use of it in any way you like.
#-------------------------------------------------------------------

#############################################################
# Install useful CMake modules.
# These are necessary to compile the samples from the install
# directory, but can also be used for custom projects.
#############################################################

if(WIN32 OR APPLE)
	set(OGRE_CMAKE_DIR "CMake")
else()
	set(OGRE_CMAKE_DIR "${OGRE_LIB_DIRECTORY}/OGRE/cmake")
endif()

set(INST_FILES
  Packages/FindOIS.cmake
  Packages/FindOGRE.cmake
  Utils/FindPkgMacros.cmake
  Utils/MacroLogFeature.cmake
  Utils/PreprocessorUtils.cmake
  Utils/OgreConfigTargets.cmake
  Utils/OgreGetVersion.cmake
  Utils/OgreFindFrameworks.cmake
) 
set(STATIC_INST_FILES
  Packages/FindCg.cmake
  Packages/FindDirectX.cmake
  Packages/FindFreeImage.cmake
  Packages/FindFreetype.cmake
  Packages/FindOpenGLES.cmake
  Packages/FindPOCO.cmake
  Packages/FindTBB.cmake
  Packages/FindZLIB.cmake
  Packages/FindZZip.cmake
)
if (WIN32)
  set(INST_FILES ${INST_FILES}
    Templates/VisualStudioUserFile.vcproj.user.in
    Templates/VisualStudioUserFile.vcxproj.user.in
  )
endif ()

if (APPLE)
  set(INST_FILES ${INST_FILES}
    Packages/FindIOKit.cmake
  )
  set(STATIC_INST_FILES ${STATIC_INST_FILES}
    Packages/FindCarbon.cmake
    Packages/FindCocoa.cmake
    Packages/FindiPhoneSDK.cmake
  )
endif ()

install(FILES ${INST_FILES} DESTINATION ${OGRE_CMAKE_DIR})
if (OGRE_STATIC)
  install(FILES ${STATIC_INST_FILES} DESTINATION ${OGRE_CMAKE_DIR})
endif ()

=== Docs/CMakeLists.txt ===
#-------------------------------------------------------------------
# This file is part of the CMake build system for OGRE
#     (Object-oriented Graphics Rendering Engine)
# For the latest info, see http://www.ogre3d.org/
#
# The contents of this file are placed in the public domain. Feel
# free to make use of it in any way you like.
#-------------------------------------------------------------------

###############################################################
# Install documentation
# Build API docs, if doxygen is available
###############################################################

# Set docs target directory
if (WIN32 OR APPLE)
  set(OGRE_DOCS_PATH "Docs")
elseif (UNIX)
  set(OGRE_DOCS_PATH "share/OGRE/docs")
endif ()
  
if (OGRE_INSTALL_DOCS)
  install(DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/
    DESTINATION ${OGRE_DOCS_PATH}
    PATTERN ".svn" EXCLUDE
    PATTERN "src" EXCLUDE
  )
endif ()

# Build and install API documentation if doxygen is available
if(DOXYGEN_FOUND)
	configure_file(${OGRE_TEMPLATES_DIR}/html.cfg.in ${OGRE_BINARY_DIR}/html.cfg)
	add_custom_target(doc COMMAND 
    ${DOXYGEN_EXECUTABLE} ${OGRE_BINARY_DIR}/html.cfg 
    WORKING_DIRECTORY ${OGRE_SOURCE_DIR}/Docs/src/ 
    COMMENT "Building documentation" VERBATIM
  )
	file(WRITE ${OGRE_BINARY_DIR}/api/temp.txt "This file should be deleted before installation. It is only here to force the creation of the api folder")
	file(REMOVE ${OGRE_BINARY_DIR}/api/temp.txt)
	if (OGRE_INSTALL_DOCS)
		install(DIRECTORY ${OGRE_BINARY_DIR}/api DESTINATION ${OGRE_DOCS_PATH})
	endif()
endif()

=== Tests/CMakeLists.txt ===
#-------------------------------------------------------------------
# This file is part of the CMake build system for OGRE
#     (Object-oriented Graphics Rendering Engine)
# For the latest info, see http://www.ogre3d.org/
#
# The contents of this file are placed in the public domain. Feel
# free to make use of it in any way you like.
#-------------------------------------------------------------------

# Configure Tests build
if (OGRE_BUILD_TESTS)

  if (CppUnit_FOUND)
	# unit tests are go!
	include_directories(${CMAKE_CURRENT_SOURCE_DIR}/OgreMain/include)
	
	set(HEADER_FILES 
		OgreMain/include/BitwiseTests.h
		OgreMain/include/EdgeBuilderTests.h
		OgreMain/include/FileSystemArchiveTests.h
		OgreMain/include/MeshWithoutIndexDataTests.h
		OgreMain/include/PixelFormatTests.h
		OgreMain/include/RadixSortTests.h
		OgreMain/include/RenderSystemCapabilitiesTests.h
		OgreMain/include/StreamSerialiserTests.h
		OgreMain/include/StringTests.h
		OgreMain/include/Suite.h
		OgreMain/include/UseCustomCapabilitiesTests.h
		OgreMain/include/VectorTests.h
	)
	set(SOURCE_FILES 
		OgreMain/src/BitwiseTests.cpp
		OgreMain/src/EdgeBuilderTests.cpp
		OgreMain/src/FileSystemArchiveTests.cpp
		OgreMain/src/MeshWithoutIndexDataTests.cpp
		OgreMain/src/PixelFormatTests.cpp
		OgreMain/src/RadixSort.cpp
		OgreMain/src/RenderSystemCapabilitiesTests.cpp
		OgreMain/src/StreamSerialiserTests.cpp
		OgreMain/src/StringTests.cpp
		OgreMain/src/Suite.cpp
		OgreMain/src/UseCustomCapabilitiesTests.cpp
		OgreMain/src/VectorTests.cpp
		src/main.cpp
	)
	if (OGRE_CONFIG_ENABLE_ZIP)
	  set(HEADER_FILES ${HEADER_FILES} OgreMain/include/ZipArchiveTests.h)
	  set(SOURCE_FILES ${SOURCE_FILES} OgreMain/src/ZipArchiveTests.cpp)
	endif ()

	if (OGRE_BUILD_COMPONENT_PAGING)
	  include_directories(${CMAKE_CURRENT_SOURCE_DIR}/Components/Paging/include)
	  ogre_add_component_include_dir(Paging)
	  
	  set(OGRE_LIBRARIES ${OGRE_LIBRARIES} OgrePaging)
	  set(HEADER_FILES ${HEADER_FILES}
	    Components/Paging/include/PageCoreTests.h
	  )
	  set(SOURCE_FILES ${SOURCE_FILES}
	    Components/Paging/src/PageCoreTests.cpp
	  )
	endif ()
	if (OGRE_BUILD_COMPONENT_TERRAIN)
	  include_directories(${CMAKE_CURRENT_SOURCE_DIR}/Components/Terrain/include)
	  ogre_add_component_include_dir(Terrain)
	  
	  set(OGRE_LIBRARIES ${OGRE_LIBRARIES} OgreTerrain)
	  set(HEADER_FILES ${HEADER_FILES}
	    Components/Terrain/include/TerrainTests.h
	  )
	  set(SOURCE_FILES ${SOURCE_FILES}
	    Components/Terrain/src/TerrainTests.cpp
	  )
	endif ()
	if (OGRE_BUILD_COMPONENT_PROPERTY)
	  include_directories(${CMAKE_CURRENT_SOURCE_DIR}/Components/Property/include
	    ${OGRE_SOURCE_DIR}/Components/Property/include)
	  
	  set(OGRE_LIBRARIES ${OGRE_LIBRARIES} OgreProperty)
	  set(HEADER_FILES ${HEADER_FILES}
	    Components/Property/include/PropertyTests.h
	  )
	  set(SOURCE_FILES ${SOURCE_FILES}
	    Components/Property/src/PropertyTests.cpp
	  )
	endif ()
	
	add_executable(Test_Ogre WIN32 ${HEADER_FILES} ${SOURCE_FILES} ${RESOURCE_FILES} )
	ogre_config_sample_exe(Test_Ogre)
	target_link_libraries(Test_Ogre ${OGRE_LIBRARIES} ${CppUnit_LIBRARIES})

  endif ()
  
  
  # Configure interactive test build
  if (OIS_FOUND)
 
	  include_directories(${CMAKE_CURRENT_SOURCE_DIR}/Common/include)

	  # Make sure all plugins are built
	  if (OGRE_BUILD_PLUGIN_OCTREE)
		set(TEST_DEPENDENCIES ${TEST_DEPENDENCIES} Plugin_OctreeSceneManager)
	  endif ()
	  if (OGRE_BUILD_PLUGIN_BSP)
		set(TEST_DEPENDENCIES ${TEST_DEPENDENCIES} Plugin_BSPSceneManager)
	  endif ()
	  if (OGRE_BUILD_PLUGIN_CG)
		set(TEST_DEPENDENCIES ${TEST_DEPENDENCIES} Plugin_CgProgramManager)
	  endif (OGRE_BUILD_PLUGIN_CG)
	  if (OGRE_BUILD_PLUGIN_PFX)
		set(TEST_DEPENDENCIES ${TEST_DEPENDENCIES} Plugin_ParticleFX)
	  endif ()
	  
	  if (OGRE_BUILD_PLUGIN_PCZ)
		set(TEST_DEPENDENCIES ${TEST_DEPENDENCIES} Plugin_PCZSceneManager)
		set(TEST_DEPENDENCIES ${TEST_DEPENDENCIES} Plugin_OctreeZone)
	  endif ()
	  
	  if (OGRE_BUILD_RENDERSYSTEM_D3D9)
		set(TEST_DEPENDENCIES ${TEST_DEPENDENCIES} RenderSystem_Direct3D9)
	  endif ()
	  if (OGRE_BUILD_RENDERSYSTEM_D3D10)
		set(TEST_DEPENDENCIES ${TEST_DEPENDENCIES} RenderSystem_Direct3D10)
	  endif ()
	  if (OGRE_BUILD_RENDERSYSTEM_D3D11)
		set(TEST_DEPENDENCIES ${TEST_DEPENDENCIES} RenderSystem_Direct3D11)
	  endif ()
	  if (OGRE_BUILD_RENDERSYSTEM_GL)
		set(TEST_DEPENDENCIES ${TEST_DEPENDENCIES} RenderSystem_GL)
	  endif ()
	  if (OGRE_BUILD_RENDERSYSTEM_GLES)
		set(TEST_DEPENDENCIES ${TEST_DEPENDENCIES} RenderSystem_GLES)
	  endif ()

	  if (OGRE_STATIC)
		# Static linking means we need to directly use plugins
		include_directories(${OGRE_SOURCE_DIR}/PlugIns/BSPSceneManager/include)
		include_directories(${OGRE_SOURCE_DIR}/PlugIns/CgProgramManager/include)
		include_directories(${OGRE_SOURCE_DIR}/PlugIns/OctreeSceneManager/include)
		include_directories(${OGRE_SOURCE_DIR}/PlugIns/OctreeZone/include)
		include_directories(${OGRE_SOURCE_DIR}/PlugIns/ParticleFX/include)
		include_directories(${OGRE_SOURCE_DIR}/PlugIns/PCZSceneManager/include)
		include_directories(${OGRE_SOURCE_DIR}/RenderSystems/Direct3D9/include)
		include_directories(${OGRE_SOURCE_DIR}/RenderSystems/Direct3D10/include)
		include_directories(${OGRE_SOURCE_DIR}/RenderSystems/GLES/include)
		include_directories(
			${OGRE_SOURCE_DIR}/RenderSystems/GL/include
			${OGRE_SOURCE_DIR}/RenderSystems/GL/src/GLSL/include
			${OGRE_SOURCE_DIR}/RenderSystems/GL/src/atifs/include
			${OGRE_SOURCE_DIR}/RenderSystems/GL/src/nvparse
			)

		# Link to all enabled plugins
		set(OGRE_LIBRARIES ${OGRE_LIBRARIES} ${TEST_DEPENDENCIES})

		# Need to include resource files so that icons are linked
		if (WIN32)
			set(RESOURCE_FILES
				${OGRE_SOURCE_DIR}/OgreMain/src/WIN32/resource.h
				${OGRE_SOURCE_DIR}/OgreMain/src/WIN32/OgreWin32Resources.rc
				${OGRE_SOURCE_DIR}/OgreMain/src/WIN32/winres.h
			)
			source_group(Resources FILES ${RESOURCE_FILES})
		endif ()	
	  endif ()

	  # PlayPen gets included always
	add_subdirectory(PlayPen)

    endif (OIS_FOUND)

endif (OGRE_BUILD_TESTS)

=== Tools/CMakeLists.txt ===
#-------------------------------------------------------------------
# This file is part of the CMake build system for OGRE
#     (Object-oriented Graphics Rendering Engine)
# For the latest info, see http://www.ogre3d.org/
#
# The contents of this file are placed in the public domain. Feel
# free to make use of it in any way you like.
#-------------------------------------------------------------------

# Configure Tools build

# Tools can't be run on the iPhone so don't build them
if (NOT OGRE_BUILD_PLATFORM_IPHONE)
  add_subdirectory(XMLConverter)
  add_subdirectory(MeshUpgrader)
endif (NOT OGRE_BUILD_PLATFORM_IPHONE)

=== Components/Property/CMakeLists.txt ===
#-------------------------------------------------------------------
# This file is part of the CMake build system for OGRE
#     (Object-oriented Graphics Rendering Engine)
# For the latest info, see http://www.ogre3d.org/
#
# The contents of this file are placed in the public domain. Feel
# free to make use of it in any way you like.
#-------------------------------------------------------------------

############################################################
# Paging optional component
############################################################

PROJECT(OgreProperty)

# define header and source files for the library
set (HEADER_FILES
	include/OgreProperty.h
	include/OgrePropertyPrerequisites.h
)

set (SOURCE_FILES
	src/OgreProperty.cpp
)


# Add needed definitions 
add_definitions(-DOGRE_PROPERTY_EXPORTS -D_MT -D_USRDLL)

# include headers
include_directories(${CMAKE_CURRENT_SOURCE_DIR}/include)
include_directories(${OGRE_SOURCE_DIR}/OgreMain/include)
include_directories(${Boost_INCLUDE_DIRS})

# setup target
add_library(OgreProperty ${OGRE_COMP_LIB_TYPE} ${HEADER_FILES} ${SOURCE_FILES} ${PLATFORM_HEADER_FILES} ${PLATFORM_SOURCE_FILES})
set_target_properties(OgreProperty PROPERTIES VERSION ${OGRE_SOVERSION})
target_link_libraries(OgreProperty OgreMain)
if (OGRE_CONFIG_THREADS)
  target_link_libraries(OgreProperty ${Boost_LIBRARIES})
endif ()

# install 
ogre_config_component(OgreProperty)

if (APPLE AND NOT OGRE_BUILD_PLATFORM_IPHONE)
    # Set the INSTALL_PATH so that Components can be installed in the application package
    set_target_properties(OgreProperty
       PROPERTIES BUILD_WITH_INSTALL_RPATH 1
       INSTALL_NAME_DIR "@executable_path/../Components"
    )

	# Copy headers into the main Ogre framework
	add_custom_command(TARGET OgreProperty POST_BUILD
	  COMMAND /Developer/Library/PrivateFrameworks/DevToolsCore.framework/Resources/pbxcp ARGS -exclude .DS_Store -exclude .hg -exclude 'CMakeLists.txt' -resolve-src-symlinks ${CMAKE_CURRENT_SOURCE_DIR}/include/*.h ${OGRE_BINARY_DIR}/lib/$(CONFIGURATION)/Ogre.framework/Headers/
	)
endif()

install(FILES ${HEADER_FILES}
  DESTINATION include/OGRE/Property
)

=== Components/RTShaderSystem/CMakeLists.txt ===
#-------------------------------------------------------------------
# This file is part of the CMake build system for OGRE
#     (Object-oriented Graphics Rendering Engine)
# For the latest info, see http://www.ogre3d.org/
#
# The contents of this file are placed in the public domain. Feel
# free to make use of it in any way you like.
#-------------------------------------------------------------------

# Configure Ogre RTShader System build

PROJECT(OgreRTShaderSystem)

set (HEADER_FILES
  include/OgreRTShaderSystem.h
  include/OgreShaderPrerequisites.h
  include/OgreShaderFFPColour.h
  include/OgreShaderFFPFog.h
  include/OgreShaderFFPLighting.h
  include/OgreShaderFFPRenderState.h
  include/OgreShaderFFPRenderStateBuilder.h
  include/OgreShaderFFPTexturing.h
  include/OgreShaderFFPTransform.h
  include/OgreShaderFunction.h
  include/OgreShaderFunctionAtom.h
  include/OgreShaderGenerator.h
  include/OgreShaderParameter.h
  include/OgreShaderProgram.h
  include/OgreShaderProgramManager.h
  include/OgreShaderProgramSet.h
  include/OgreShaderProgramWriter.h
  include/OgreShaderRenderState.h
  include/OgreShaderSubRenderState.h
  include/OgreShaderExNormalMapLighting.h
  include/OgreShaderExPerPixelLighting.h
  include/OgreShaderExIntegratedPSSM3.h
  include/OgreShaderScriptTranslator.h
  include/OgreShaderMaterialSerializerListener.h
  include/OgreShaderProgramProcessor.h
  include/OgreShaderCGProgramProcessor.h
  include/OgreShaderCGProgramWriter.h
  include/OgreShaderGLSLProgramProcessor.h
  include/OgreShaderGLSLProgramWriter.h
  include/OgreShaderProgramWriterManager.h
  include/OgreShaderHLSLProgramProcessor.h
  include/OgreShaderHLSLProgramWriter.h
)

set (SOURCE_FILES
  src/OgreShaderFFPColour.cpp
  src/OgreShaderFFPFog.cpp
  src/OgreShaderFFPLighting.cpp
  src/OgreShaderFFPRenderStateBuilder.cpp
  src/OgreShaderFFPTexturing.cpp
  src/OgreShaderFFPTransform.cpp
  src/OgreShaderFunction.cpp
  src/OgreShaderFunctionAtom.cpp
  src/OgreShaderGenerator.cpp
  src/OgreShaderParameter.cpp
  src/OgreShaderProgram.cpp
  src/OgreShaderProgramManager.cpp
  src/OgreShaderProgramSet.cpp
  src/OgreShaderProgramWriter.cpp
  src/OgreShaderRenderState.cpp
  src/OgreShaderSubRenderState.cpp
  src/OgreShaderExNormalMapLighting.cpp
  src/OgreShaderExPerPixelLighting.cpp
  src/OgreShaderExIntegratedPSSM3.cpp
  src/OgreShaderScriptTranslator.cpp
  src/OgreShaderMaterialSerializerListener.cpp
  src/OgreShaderProgramProcessor.cpp
  src/OgreShaderCGProgramProcessor.cpp
  src/OgreShaderCGProgramWriter.cpp
  src/OgreShaderGLSLProgramProcessor.cpp
  src/OgreShaderGLSLProgramWriter.cpp
  src/OgreShaderProgramWriterManager.cpp
  src/OgreShaderHLSLProgramProcessor.cpp
  src/OgreShaderHLSLProgramWriter.cpp
)

include_directories(${CMAKE_CURRENT_SOURCE_DIR}/include)

add_library(OgreRTShaderSystem ${OGRE_COMP_LIB_TYPE} ${HEADER_FILES} ${SOURCE_FILES})
set_target_properties(OgreRTShaderSystem PROPERTIES VERSION ${OGRE_SOVERSION})
target_link_libraries(OgreRTShaderSystem OgreMain)

ogre_config_component(OgreRTShaderSystem)

if (APPLE AND NOT OGRE_BUILD_PLATFORM_IPHONE)
    # Set the INSTALL_PATH so that Components can be installed in the application package
    set_target_properties(OgreRTShaderSystem
       PROPERTIES BUILD_WITH_INSTALL_RPATH 1
       INSTALL_NAME_DIR "@executable_path/../Components"
    )

	# Copy headers into the main Ogre framework
	add_custom_command(TARGET OgreRTShaderSystem POST_BUILD
	  COMMAND /Developer/Library/PrivateFrameworks/DevToolsCore.framework/Resources/pbxcp ARGS -exclude .DS_Store -exclude .hg -exclude 'CMakeLists.txt' -resolve-src-symlinks ${CMAKE_CURRENT_SOURCE_DIR}/include/*.h ${OGRE_BINARY_DIR}/lib/$(CONFIGURATION)/Ogre.framework/Headers/
	)
endif()


install(FILES ${HEADER_FILES}
  DESTINATION include/OGRE/RTShaderSystem
)

=== PlugIns/OctreeZone/CMakeLists.txt ===
#-------------------------------------------------------------------
# This file is part of the CMake build system for OGRE
#     (Object-oriented Graphics Rendering Engine)
# For the latest info, see http://www.ogre3d.org/
#
# The contents of this file are placed in the public domain. Feel
# free to make use of it in any way you like.
#-------------------------------------------------------------------

# Configure OctreeZone SceneManager build

set (HEADER_FILES
  include/OgreHeightmapTerrainZonePageSource.h
  include/OgreOctreeZone.h
  include/OgreOctreeZoneOctree.h
  include/OgreOctreeZonePlugin.h
  include/OgreOctreeZonePrerequisites.h
  include/OgreTerrainVertexProgram.h
  include/OgreTerrainZone.h
  include/OgreTerrainZonePage.h
  include/OgreTerrainZonePageSource.h
  include/OgreTerrainZonePrerequisites.h
  include/OgreTerrainZoneRenderable.h
)

set (SOURCE_FILES
  src/OgreHeightmapTerrainZonePageSource.cpp
  src/OgreOctreeZone.cpp
  src/OgreOctreeZoneDll.cpp
  src/OgreOctreeZoneOctree.cpp
  src/OgreOctreeZonePlugin.cpp
  src/OgreTerrainVertexProgram.cpp
  src/OgreTerrainZone.cpp
  src/OgreTerrainZonePage.cpp
  src/OgreTerrainZonePageSource.cpp
  src/OgreTerrainZoneRenderable.cpp
)

include_directories(${CMAKE_CURRENT_SOURCE_DIR}/include)
include_directories(${CMAKE_CURRENT_SOURCE_DIR}/../PCZSceneManager/include)
add_definitions(-D_USRDLL)

add_library(Plugin_OctreeZone ${OGRE_LIB_TYPE} ${HEADER_FILES} ${SOURCE_FILES})
target_link_libraries(Plugin_OctreeZone OgreMain Plugin_PCZSceneManager)
if (NOT OGRE_STATIC)
  set_property(TARGET Plugin_OctreeZone PROPERTY
    COMPILE_DEFINITIONS OGRE_OCTREEZONEPLUGIN_EXPORTS)
endif ()

# need to include the plugins directory in the RPATH for OctreeZone to be able
# to find the PCZSceneManager library
if (UNIX)
  set_property(TARGET Plugin_OctreeZone APPEND PROPERTY
    INSTALL_RPATH ${CMAKE_INSTALL_PREFIX}/${OGRE_LIB_DIRECTORY}/OGRE
  )
endif ()

if (APPLE AND NOT OGRE_BUILD_PLATFORM_IPHONE)
    # Set the INSTALL_PATH so that Plugins can be installed in the application package
    set_target_properties(Plugin_OctreeZone
       PROPERTIES BUILD_WITH_INSTALL_RPATH 1
       INSTALL_NAME_DIR "@executable_path/../Plugins"
    )

	# Copy headers into the main Ogre framework
	add_custom_command(TARGET Plugin_OctreeZone POST_BUILD
	  COMMAND /Developer/Library/PrivateFrameworks/DevToolsCore.framework/Resources/pbxcp ARGS -exclude .DS_Store -exclude .hg -exclude 'CMakeLists.txt' -resolve-src-symlinks ${CMAKE_CURRENT_SOURCE_DIR}/include/*.h ${OGRE_BINARY_DIR}/lib/$(CONFIGURATION)/Ogre.framework/Headers/
	)
endif()

ogre_config_plugin(Plugin_OctreeZone)
install(FILES ${HEADER_FILES} DESTINATION include/OGRE/Plugins/OctreeZone)

=== RenderSystems/Direct3D10/CMakeLists.txt ===
#-------------------------------------------------------------------
# This file is part of the CMake build system for OGRE
#     (Object-oriented Graphics Rendering Engine)
# For the latest info, see http://www.ogre3d.org/
#
# The contents of this file are placed in the public domain. Feel
# free to make use of it in any way you like.
#-------------------------------------------------------------------

# Configure Direct3D10 RenderSystem build

set (HEADER_FILES
  include/OgreD3D10Device.h
  include/OgreD3D10Driver.h
  include/OgreD3D10DriverList.h
  include/OgreD3D10GpuProgram.h
  include/OgreD3D10GpuProgramManager.h
  include/OgreD3D10HardwareBuffer.h
  include/OgreD3D10HardwareBufferManager.h
  include/OgreD3D10HardwareIndexBuffer.h
  include/OgreD3D10HardwareOcclusionQuery.h
  include/OgreD3D10HardwarePixelBuffer.h
  include/OgreD3D10HardwareVertexBuffer.h
  include/OgreD3D10HLSLProgram.h
  include/OgreD3D10HLSLProgramFactory.h
  include/OgreD3D10Mappings.h
  include/OgreD3D10MultiRenderTarget.h
  include/OgreD3D10Plugin.h
  include/OgreD3D10Prerequisites.h
  include/OgreD3D10RenderSystem.h
  include/OgreD3D10RenderToVertexBuffer.h
  include/OgreD3D10RenderWindow.h
  include/OgreD3D10Texture.h
  include/OgreD3D10TextureManager.h
  include/OgreD3D10VertexDeclaration.h
  include/OgreD3D10VideoMode.h
  include/OgreD3D10VideoModeList.h
  include/OgreFixedFuncEmuShaderGenerator.h
  include/OgreFixedFuncEmuShaderManager.h
  include/OgreFixedFuncState.h
  include/OgreHlslFixedFuncEmuShaderGenerator.h
)

set (SOURCE_FILES
  src/OgreD3D10Device.cpp
  src/OgreD3D10Driver.cpp
  src/OgreD3D10DriverList.cpp
  src/OgreD3D10EngineDll.cpp
  src/OgreD3D10GpuProgram.cpp
  src/OgreD3D10GpuProgramManager.cpp
  src/OgreD3D10HardwareBuffer.cpp
  src/OgreD3D10HardwareBufferManager.cpp
  src/OgreD3D10HardwareIndexBuffer.cpp
  src/OgreD3D10HardwareOcclusionQuery.cpp
  src/OgreD3D10HardwarePixelBuffer.cpp
  src/OgreD3D10HardwareVertexBuffer.cpp
  src/OgreD3D10HLSLProgram.cpp
  src/OgreD3D10HLSLProgramFactory.cpp
  src/OgreD3D10Mappings.cpp
  src/OgreD3D10MultiRenderTarget.cpp
  src/OgreD3D10Plugin.cpp
  src/OgreD3D10RenderSystem.cpp
  src/OgreD3D10RenderToVertexBuffer.cpp
  src/OgreD3D10RenderWindow.cpp
  src/OgreD3D10Texture.cpp
  src/OgreD3D10TextureManager.cpp
  src/OgreD3D10VertexDeclaration.cpp
  src/OgreD3D10VideoMode.cpp
  src/OgreD3D10VideoModeList.cpp
  src/OgreFixedFuncEmuShaderGenerator.cpp
  src/OgreFixedFuncEmuShaderManager.cpp
  src/OgreFixedFuncState.cpp
  src/OgreHlslFixedFuncEmuShaderGenerator.cpp

)

include_directories(${CMAKE_CURRENT_SOURCE_DIR}/include ${DirectX_INCLUDE_DIR})
link_directories(${DirectX_LIBRARY_DIR})
add_definitions(-D_USRDLL)

add_library(RenderSystem_Direct3D10 ${OGRE_LIB_TYPE} ${HEADER_FILES} ${SOURCE_FILES})
target_link_libraries(RenderSystem_Direct3D10
  OgreMain
  ${DirectX_D3D10_LIBRARIES}
)

if (NOT OGRE_STATIC)
  set_target_properties(RenderSystem_Direct3D10 PROPERTIES
    COMPILE_DEFINITIONS OGRED3DENGINEDLL_EXPORTS
  )
endif ()
if (OGRE_CONFIG_THREADS)
  target_link_libraries(RenderSystem_Direct3D10 ${Boost_LIBRARIES})
endif ()

ogre_config_plugin(RenderSystem_Direct3D10)
install(FILES ${HEADER_FILES} DESTINATION include/OGRE/RenderSystems/Direct3D10)

=== RenderSystems/Direct3D11/CMakeLists.txt ===
#-------------------------------------------------------------------
# This file is part of the CMake build system for OGRE
#     (Object-oriented Graphics Rendering Engine)
# For the latest info, see http://www.ogre3d.org/
#
# The contents of this file are placed in the public domain. Feel
# free to make use of it in any way you like.
#-------------------------------------------------------------------

# Configure Direct3D11 RenderSystem build

set (HEADER_FILES
  include/OgreD3D11Device.h
  include/OgreD3D11Driver.h
  include/OgreD3D11DriverList.h
  include/OgreD3D11GpuProgram.h
  include/OgreD3D11GpuProgramManager.h
  include/OgreD3D11HardwareBuffer.h
  include/OgreD3D11HardwareBufferManager.h
  include/OgreD3D11HardwareIndexBuffer.h
  include/OgreD3D11HardwareOcclusionQuery.h
  include/OgreD3D11HardwarePixelBuffer.h
  include/OgreD3D11HardwareVertexBuffer.h
  include/OgreD3D11HLSLProgram.h
  include/OgreD3D11HLSLProgramFactory.h
  include/OgreD3D11Mappings.h
  include/OgreD3D11MultiRenderTarget.h
  include/OgreD3D11Plugin.h
  include/OgreD3D11Prerequisites.h
  include/OgreD3D11RenderSystem.h
  include/OgreD3D11RenderToVertexBuffer.h
  include/OgreD3D11RenderWindow.h
  include/OgreD3D11Texture.h
  include/OgreD3D11TextureManager.h
  include/OgreD3D11VertexDeclaration.h
  include/OgreD3D11VideoMode.h
  include/OgreD3D11VideoModeList.h
  include/OgreFixedFuncEmuShaderGenerator.h
  include/OgreFixedFuncEmuShaderManager.h
  include/OgreFixedFuncState.h
  include/OgreHlslFixedFuncEmuShaderGenerator.h
)

set (SOURCE_FILES
  src/OgreD3D11Device.cpp
  src/OgreD3D11Driver.cpp
  src/OgreD3D11DriverList.cpp
  src/OgreD3D11EngineDll.cpp
  src/OgreD3D11GpuProgram.cpp
  src/OgreD3D11GpuProgramManager.cpp
  src/OgreD3D11HardwareBuffer.cpp
  src/OgreD3D11HardwareBufferManager.cpp
  src/OgreD3D11HardwareIndexBuffer.cpp
  src/OgreD3D11HardwareOcclusionQuery.cpp
  src/OgreD3D11HardwarePixelBuffer.cpp
  src/OgreD3D11HardwareVertexBuffer.cpp
  src/OgreD3D11HLSLProgram.cpp
  src/OgreD3D11HLSLProgramFactory.cpp
  src/OgreD3D11Mappings.cpp
  src/OgreD3D11MultiRenderTarget.cpp
  src/OgreD3D11Plugin.cpp
  src/OgreD3D11RenderSystem.cpp
  src/OgreD3D11RenderToVertexBuffer.cpp
  src/OgreD3D11RenderWindow.cpp
  src/OgreD3D11Texture.cpp
  src/OgreD3D11TextureManager.cpp
  src/OgreD3D11VertexDeclaration.cpp
  src/OgreD3D11VideoMode.cpp
  src/OgreD3D11VideoModeList.cpp
  src/OgreFixedFuncEmuShaderGenerator.cpp
  src/OgreFixedFuncEmuShaderManager.cpp
  src/OgreFixedFuncState.cpp
  src/OgreHlslFixedFuncEmuShaderGenerator.cpp

)

include_directories(${CMAKE_CURRENT_SOURCE_DIR}/include ${DirectX_INCLUDE_DIR})
link_directories(${DirectX_LIBRARY_DIR})
add_definitions(-D_USRDLL)

add_library(RenderSystem_Direct3D11 ${OGRE_LIB_TYPE} ${HEADER_FILES} ${SOURCE_FILES})
target_link_libraries(RenderSystem_Direct3D11
  OgreMain
  ${DirectX_D3D11_LIBRARIES}
)

if (NOT OGRE_STATIC)
  set_target_properties(RenderSystem_Direct3D11 PROPERTIES
    COMPILE_DEFINITIONS OGRED3DENGINEDLL_EXPORTS
  )
endif ()
if (OGRE_CONFIG_THREADS)
  target_link_libraries(RenderSystem_Direct3D11 ${Boost_LIBRARIES})
endif ()

ogre_config_plugin(RenderSystem_Direct3D11)
install(FILES ${HEADER_FILES} DESTINATION include/OGRE/RenderSystems/Direct3D11)

=== RenderSystems/Direct3D9/CMakeLists.txt ===
#-------------------------------------------------------------------
# This file is part of the CMake build system for OGRE
#     (Object-oriented Graphics Rendering Engine)
# For the latest info, see http://www.ogre3d.org/
#
# The contents of this file are placed in the public domain. Feel
# free to make use of it in any way you like.
#-------------------------------------------------------------------

# Configure Direct3D9 RenderSystem build

set (HEADER_FILES
  include/OgreD3D9Device.h
  include/OgreD3D9DeviceManager.h
  include/OgreD3D9Driver.h
  include/OgreD3D9DriverList.h
  include/OgreD3D9GpuProgram.h
  include/OgreD3D9GpuProgramManager.h
  include/OgreD3D9HardwareBufferManager.h
  include/OgreD3D9HardwareIndexBuffer.h
  include/OgreD3D9HardwareOcclusionQuery.h
  include/OgreD3D9HardwarePixelBuffer.h
  include/OgreD3D9HardwareVertexBuffer.h
  include/OgreD3D9HLSLProgram.h
  include/OgreD3D9HLSLProgramFactory.h
  include/OgreD3D9Mappings.h
  include/OgreD3D9MultiRenderTarget.h
  include/OgreD3D9Plugin.h
  include/OgreD3D9Prerequisites.h
  include/OgreD3D9RenderSystem.h
  include/OgreD3D9RenderWindow.h
  include/OgreD3D9Resource.h
  include/OgreD3D9ResourceManager.h
  include/OgreD3D9Texture.h
  include/OgreD3D9TextureManager.h
  include/OgreD3D9VertexDeclaration.h
  include/OgreD3D9VideoMode.h
  include/OgreD3D9VideoModeList.h
)

set (SOURCE_FILES
  src/OgreD3D9Device.cpp
  src/OgreD3D9DeviceManager.cpp
  src/OgreD3D9Driver.cpp
  src/OgreD3D9DriverList.cpp
  src/OgreD3D9EngineDll.cpp
  src/OgreD3D9GpuProgram.cpp
  src/OgreD3D9GpuProgramManager.cpp
  src/OgreD3D9HardwareBufferManager.cpp
  src/OgreD3D9HardwareIndexBuffer.cpp
  src/OgreD3D9HardwareOcclusionQuery.cpp
  src/OgreD3D9HardwarePixelBuffer.cpp
  src/OgreD3D9HardwareVertexBuffer.cpp
  src/OgreD3D9HLSLProgram.cpp
  src/OgreD3D9HLSLProgramFactory.cpp
  src/OgreD3D9Mappings.cpp
  src/OgreD3D9MultiRenderTarget.cpp
  src/OgreD3D9Plugin.cpp
  src/OgreD3D9RenderSystem.cpp
  src/OgreD3D9RenderWindow.cpp
  src/OgreD3D9Resource.cpp
  src/OgreD3D9ResourceManager.cpp
  src/OgreD3D9Texture.cpp
  src/OgreD3D9TextureManager.cpp
  src/OgreD3D9VertexDeclaration.cpp
  src/OgreD3D9VideoMode.cpp
  src/OgreD3D9VideoModeList.cpp
)

if (MINGW)
  list(APPEND HEADER_FILES ${OGRE_SOURCE_DIR}/OgreMain/include/WIN32/OgreMinGWSupport.h)
  list(APPEND SOURCE_FILES ${OGRE_SOURCE_DIR}/OgreMain/src/WIN32/OgreMinGWSupport.cpp)
endif ()

include_directories(${CMAKE_CURRENT_SOURCE_DIR}/include ${DirectX_INCLUDE_DIR})
link_directories(${DirectX_LIBRARY_DIR})
add_definitions(-D_USRDLL)

add_library(RenderSystem_Direct3D9 ${OGRE_LIB_TYPE} ${HEADER_FILES} ${SOURCE_FILES})
target_link_libraries(RenderSystem_Direct3D9
  OgreMain
  ${DirectX_LIBRARIES}
)

if (NOT OGRE_STATIC)
  set_target_properties(RenderSystem_Direct3D9 PROPERTIES
    COMPILE_DEFINITIONS OGRED3DENGINEDLL_EXPORTS
  )
endif ()
if (OGRE_CONFIG_THREADS)
  target_link_libraries(RenderSystem_Direct3D9 ${Boost_LIBRARIES})
endif ()

ogre_config_plugin(RenderSystem_Direct3D9)
install(FILES ${HEADER_FILES} DESTINATION include/OGRE/RenderSystems/Direct3D9)

=== Tools/XMLConverter/CMakeLists.txt ===
#-------------------------------------------------------------------
# This file is part of the CMake build system for OGRE
#     (Object-oriented Graphics Rendering Engine)
# For the latest info, see http://www.ogre3d.org/
#
# The contents of this file are placed in the public domain. Feel
# free to make use of it in any way you like.
#-------------------------------------------------------------------

# Configure XMLConverter

set(HEADER_FILES 
  include/OgreXMLMeshSerializer.h
  include/OgreXMLPrerequisites.h
  include/OgreXMLSkeletonSerializer.h
  include/tinystr.h
  include/tinyxml.h
)

set(SOURCE_FILES 
  src/main.cpp
  src/OgreXMLMeshSerializer.cpp
  src/OgreXMLSkeletonSerializer.cpp
  src/tinystr.cpp
  src/tinyxml.cpp
  src/tinyxmlerror.cpp
  src/tinyxmlparser.cpp
)

include_directories(${CMAKE_CURRENT_SOURCE_DIR}/include)
add_definitions(-DTIXML_USE_STL)
add_executable(OgreXMLConverter ${HEADER_FILES} ${SOURCE_FILES})
target_link_libraries(OgreXMLConverter ${OGRE_LIBRARIES})
ogre_config_tool(OgreXMLConverter)

=== debian/changelog ===
ogre (1.7.4+dfsg1-7) unstable; urgency=low

  * Document some files oversought in debian/copyright (Closes: #690200).
    Thanks Bart Martens and Anton Gladky for reporting and collaborating in
    fixing the problem.
  * Patches:
    - Add remove-alignment.patch to drop obsolete stack alignment hack that
      breaks with gcc-4.7 (removed in upstream 1.8.1), and causes crashes on
      some architectures when using skeletons (possibly affecting a broad range
      of OGRE applications).  The patch is a modified version by me from the
      patch applied to 1.8.1, upstream does not support 1.7 series anymore.
      Thanks to Julian Taylor and Kai Mast for the report and point to upstream
      patch to 1.8 (#687013), and Nicolas Bourdaud for pointing to the problem
      in 1.7 series as well (Closes: #692397).

 -- Manuel A. Fernandez Montecelo <manuel.montezelo@gmail.com>  Tue, 13 Nov 2012 22:05:00 +0000

ogre (1.7.4+dfsg1-6) unstable; urgency=low

  * Remove Samples altogether, since almost all of them contain or depend on
    non-free items (fonts and some media objects, see Debian and upstream bug
    report).
    After contacting upstream, they are not inclined to resolve the issue soon
    (read: it will take years and several major releases, if it happens at all).
    All of them are removed and there will be no attempt to track which ones are
    DFSG-compliant; it is quite a burden (thus decreasing the time that can be
    devoted to maintain the package in good shape, follow closely upstream
    updates, etc), and this is even more complicated with different sets of
    samples in every release (as it is the case now, with v1.7 and v1.8 in the
    Debian archive).
    This change encompasses the following actions/changes:
    - Repack the source (simply removing all ./Samples/)
    - Remove patch change_sample_cfg_path.patch, of no use now
    - Remove corresponding sample packages from debian/control
    - Remove files debian/*samples*.install
    - Closes: #684218 ("ogre contains non-free font from larabie collection")
  * Force Build-Depends and Depends of libogre-dev on version 1.49 (this
    particular one since it is the default for Wheezy).  OGRE exposes internal
    source code from boost which is sometimes incompatible between versions and
    might produce deadlocks with applications using/linking incompatible
    versions of boost.  The problem is probably not fixed completely, but this
    is an attempt to mitigate it (see the bug report for the discussion).
    Thanks Paul D Turner for the toughtful report and Steve M. Robbins for
    feedback.  (Closes: #674633).

 -- Manuel A. Fernandez Montecelo <manuel.montezelo@gmail.com>  Wed, 10 Oct 2012 20:47:20 +0100

ogre (1.7.4-5) unstable; urgency=low

  * Modify options to avoid CPPFLAGS hardening flags missing (Closes: #665324)
  * Minor modifications to debian/copyright to avoid lintian warnings about
    non-conformant fields

 -- Manuel A. Fernandez Montecelo <manuel.montezelo@gmail.com>  Mon, 30 Apr 2012 17:26:58 +0100

ogre (1.7.4-4) unstable; urgency=low

  * Build-depends on libois-dev changed to [linux-any] only, and samples
    packages built for only for [linux-any] as well, since OIS does not build in
    non-Linux kernels/architectures (Closes: #664548).
  * Small reformat to debian/copyright to follow standards (a paragraph, content
    of a field, without a leading space)

 -- Manuel A. Fernandez Montecelo <manuel.montezelo@gmail.com>  Sun, 18 Mar 2012 22:01:08 +0000

=== debian/control ===
Source: ogre
Priority: optional
Section: libs
Standards-Version: 3.9.3
Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders: Manuel A. Fernandez Montecelo <manuel.montezelo@gmail.com>
DM-Upload-Allowed: yes
Homepage: http://ogre3d.org/
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-games/ogre.git
Vcs-Git: git://anonscm.debian.org/pkg-games/ogre.git
Build-Depends: debhelper (>= 9~),
               dpkg-dev (>= 1.16.1~),
               cmake (>= 2.8.0),
               pkg-config,
               libboost-date-time1.49-dev,
               libboost-thread1.49-dev,
               libfreeimage-dev,
               libfreetype6-dev,
               libzzip-dev,
               zlib1g-dev,
               libz-dev,
               libglu1-mesa-dev | libglu-dev,
               libgl1-mesa-dev | libgl-dev,
               libxrandr-dev,
               libxxf86vm-dev,
               libxaw7-dev,
               libxt-dev,
               chrpath,
               libois-dev [linux-any]

Package: libogre-dev
Section: libdevel
Architecture: any
Depends: ${misc:Depends},
         libogre-1.7.4 (= ${binary:Version}),
         libboost-date-time1.49-dev,
         libboost-thread1.49-dev,
         libfreeimage-dev,
         libfreetype6-dev,
         libzzip-dev,
         libxaw7-dev
Suggests: ogre-doc
Description: 3D Object-Oriented Graphics Rendering Engine (development files)
 OGRE (Object-Oriented Graphics Rendering Engine) is a scene-oriented, flexible
 3D engine written in C++ designed to make it easier and more intuitive for
 developers to produce applications utilising hardware-accelerated 3D
 graphics. The class library abstracts all the details of using the underlying
 system libraries like Direct3D and OpenGL and provides an interface based on
 world objects and other intuitive classes.
 .
 This package contains the headers needed to develop with OGRE.

Package: libogre-1.7.4
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends},
	     dpkg (>= 1.15.7.2~)
Depends: ${misc:Depends},
         ${shlibs:Depends}
Replaces: libogremain-1.4.9,
          libogremain-1.6.4,
          libogremain-1.7.1,
          libogre-1.7.3
Breaks: libogremain-1.4.9,
        libogremain-1.6.4,
        libogremain-1.7.1,
        libogre-1.7.3
Description: 3D Object-Oriented Graphics Rendering Engine (libraries)
 OGRE (Object-Oriented Graphics Rendering Engine) is a scene-oriented, flexible
 3D engine written in C++ designed to make it easier and more intuitive for
 developers to produce applications utilising hardware-accelerated 3D
 graphics. The class library abstracts all the details of using the underlying
 system libraries like Direct3D and OpenGL and provides an interface based on
 world objects and other intuitive classes.
 .
 This package contains the library and plugins.

Package: libogre-1.7.4-dbg
Section: debug
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Priority: extra
Depends: ${misc:Depends},
         libogre-1.7.4 (= ${binary:Version})
Replaces: libogremain-1.4.9-dbg,
          libogremain-1.6.4-dbg,
          libogremain-1.7.1-dbg,
          libogre-1.7.3-dbg
Breaks: libogremain-1.4.9-dbg,
        libogremain-1.6.4-dbg,
        libogremain-1.7.1-dbg,
        libogre-1.7.3-dbg
Description: 3D Object-Oriented Graphics Rendering Engine (debugging libs)
 OGRE (Object-Oriented Graphics Rendering Engine) is a scene-oriented, flexible
 3D engine written in C++ designed to make it easier and more intuitive for
 developers to produce applications utilising hardware-accelerated 3D
 graphics. The class library abstracts all the details of using the underlying
 system libraries like Direct3D and OpenGL and provides an interface based on
 world objects and other intuitive classes.
 .
 This package contains the debugging version of the library and plugins.

Package: ogre-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Description: 3D Object-Oriented Graphics Rendering Engine (documentation)
 OGRE (Object-Oriented Graphics Rendering Engine) is a scene-oriented, flexible
 3D engine written in C++ designed to make it easier and more intuitive for
 developers to produce applications utilising hardware-accelerated 3D
 graphics. The class library abstracts all the details of using the underlying
 system libraries like Direct3D and OpenGL and provides an interface based on
 world objects and other intuitive classes.
 .
 This package contains the documentation.

Package: ogre-tools
Section: devel
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: 3D Object-Oriented Graphics Rendering Engine (tools)
 OGRE (Object-Oriented Graphics Rendering Engine) is a scene-oriented, flexible
 3D engine written in C++ designed to make it easier and more intuitive for
 developers to produce applications utilising hardware-accelerated 3D
 graphics. The class library abstracts all the details of using the underlying
 system libraries like Direct3D and OpenGL and provides an interface based on
 world objects and other intuitive classes.
 .
 This package contains tools used to convert from and to OGRE's native mesh
 format.

Package: blender-ogrexml
Section: graphics
Architecture: all
Depends: ${misc:Depends},
         blender
Description: Blender Exporter for OGRE
 OGRE (Object-Oriented Graphics Rendering Engine) is a scene-oriented, flexible
 3D engine written in C++ designed to make it easier and more intuitive for
 developers to produce applications utilising hardware-accelerated 3D
 graphics. The class library abstracts all the details of using the underlying
 system libraries like Direct3D and OpenGL and provides an interface based on
 world objects and other intuitive classes.
 .
 This package contains the Blender exporter for OGRE.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1


# mafm 1.7.3-4: Disabling extra hardening and -Wl,-Bsymbolic because of
# Launchpad bug #913523
#
#export DEB_BUILD_MAINT_OPTIONS := hardening=+pie,+bindnow
export DEB_BUILD_MAINT_OPTIONS   := hardening=+bindnow
# CMake doesn't use CPPFLAGS, pass them to CFLAGS/CXXFLAGS to enable the
# missing (hardening) flags. dpkg_buildflags is necessary because $(shell ..)
# doesn't use local environment variables. (bug #665324)
dpkg_buildflags = DEB_BUILD_MAINT_OPTIONS=$(DEB_BUILD_MAINT_OPTIONS) dpkg-buildflags
export DEB_CFLAGS_MAINT_APPEND   := -pipe -Wall $(shell $(dpkg_buildflags) --get CPPFLAGS)
export DEB_CXXFLAGS_MAINT_APPEND := -pipe -Wall $(shell $(dpkg_buildflags) --get CPPFLAGS)
export DEB_LDFLAGS_MAINT_APPEND  := -Wl,-z,defs -Wl,--as-needed


DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)


# Use this variable to define the particular version of OGRE that we're building
OGRE_VERSION=1.7.4

OGRE_CHANGELOG = Docs/ChangeLog.html

# Directories to install with Multi-arch and versioned OGRE dir names
LIB_MULTIARCH_DIR = /usr/lib/$(DEB_HOST_MULTIARCH)
LIB_MULTIARCH_PRIVATE_DIR = /usr/lib/$(DEB_HOST_MULTIARCH)/OGRE-$(OGRE_VERSION)


%:
	dh $@ --buildsystem=cmake --parallel

override_dh_auto_configure:
        # Samples removed (do not meet DFSG), modify CMake files accordingly
	sed -i 's|^add_subdirectory(Samples)|#add_subdirectory(Samples)|' CMakeLists.txt

        # RPATH from http://www.ogre3d.org/tikiwiki/Building+Ogre+With+CMake
	dh_auto_configure -- \
		-DOGRE_LIB_DIRECTORY="lib/$(DEB_HOST_MULTIARCH)" \
		-DOGRE_FULL_RPATH:BOOL=FALSE \
		-DOGRE_BUILD_SAMPLES:BOOL=FALSE \
		-DOGRE_INSTALL_SAMPLES:BOOL=FALSE \
		-DOGRE_INSTALL_SAMPLES_SOURCE:BOOL=FALSE

override_dh_install:
        # Copy files from template for this particular version
	cp -f debian/libogre-VERSION.install debian/libogre-$(OGRE_VERSION).install
	cp -f debian/libogre-VERSION.lintian-overrides debian/libogre-$(OGRE_VERSION).lintian-overrides
	cp -f debian/libogre-VERSION.preinst debian/libogre-$(OGRE_VERSION).preinst
	cp -f debian/libogre-VERSION.postinst debian/libogre-$(OGRE_VERSION).postinst
	cp -f debian/libogre-VERSION.postrm debian/libogre-$(OGRE_VERSION).postrm

        # Workaround for CMake and debhelper with mutiarch (Debian bug:
        # http://bugs.debian.org/cgi-bin/bugreport.cgi?bug=641051 )
        #
        # Using cmake's OGRE_LIB_DIRECTORY now
        #
        #sed -i "/^libdir=/ s|/lib|/lib/$(DEB_HOST_MULTIARCH)|" debian/tmp/usr/lib/pkgconfig/*
        #sed -i "/{libdir}/ s|{libdir}/OGRE|{libdir}/OGRE-$(OGRE_VERSION)|g" debian/tmp/usr/lib/pkgconfig/*
        #
        # Moving libraries by hand
        #mkdir -p /tmp/$(DEB_HOST_MULTIARCH)
        #mv debian/tmp/usr/lib/* /tmp/$(DEB_HOST_MULTIARCH)/
        #mv /tmp/$(DEB_HOST_MULTIARCH) debian/tmp/usr/lib/

        # Introduced in 1.7.3-5 as an attempt at using versioned files/dirs for
        # plugins and config files (so several versions of OGRE can be installed
        # at once)
	mv debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/OGRE debian/tmp/$(LIB_MULTIARCH_PRIVATE_DIR)
	sed -i "/{libdir}/ s|{libdir}/OGRE|{libdir}/OGRE-$(OGRE_VERSION)|g" debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/pkgconfig/*
        # Samples
        #mv debian/tmp/usr/share/OGRE debian/tmp/usr/share/OGRE-$(OGRE_VERSION)
        #sed -i "/OGRE/ s|/OGRE|/OGRE-$(OGRE_VERSION)|g" debian/tmp/usr/share/OGRE-$(OGRE_VERSION)/*.cfg

        # multi-arch/rpath issue with lintian:
        # E: libogre-1.7.3: binary-or-shlib-defines-rpath usr/lib/x86_64-linux-gnu/OGRE/Plugin_OctreeZone.so /usr/lib/OGRE
	chrpath --replace $(LIB_MULTIARCH_PRIVATE_DIR) debian/tmp/$(LIB_MULTIARCH_PRIVATE_DIR)/Plugin_OctreeZone.so

	dh_install --fail-missing

        # More fixes for multi-arch introduced in 1.7.3-5, and attempt at using
        # versioned files for plugins and config files (so several versions can
        # be installed at once)
        #
        # As of 1.7.3-6, not shipping /etc/OGRE*/plugins.cfg anymore
        #
        #sed -i "/^PluginFolder=/ s|MULTIARCH_TRIPLET/OGRE_VERSION|$(DEB_HOST_MULTIARCH)/OGRE-$(OGRE_VERSION)|" debian/libogre-$(OGRE_VERSION)/etc/OGRE/plugins.cfg
        #mv debian/libogre-$(OGRE_VERSION)/etc/OGRE debian/libogre-$(OGRE_VERSION)/etc/OGRE-$(OGRE_VERSION)

override_dh_installchangelogs:
	dh_installchangelogs -- $(OGRE_CHANGELOG)

override_dh_strip:
	dh_strip -plibogre-$(OGRE_VERSION) --dbg-package=libogre-$(OGRE_VERSION)-dbg
	dh_strip -pogre-tools
        #dh_strip -pogre-samples --dbg-package=ogre-samples-dbg

override_dh_clean:
	dh_clean

        # Remove files from template
	rm -rf debian/libogre-$(OGRE_VERSION).*
